#include <math.h>
#include "mat_operations.h"


void dotProduct44(float a[4][4], float b[4][4], float c[4][4]) {

	int i, j, k;
	float sum = 0;

	for (i = 0; i < 4; i++) {
		for (j = 0; j < 4; j++) {
			sum = 0;
			for (k = 0; k < 4; k++) {
				sum = sum + a[i][k] * b[k][j];
			}
			c[i][j] = sum;
		}
	}
}

void scaleMat41(float a[4][1], float scale, float b[4][1]) {

	int i, j, k;
	float sum = 0;

	for (i = 0; i < 4; i++) {


			b[i][0] = a[i][0]*scale;

	}
}

void dotProduct41(float a[4][4], float b[4][1], float c[4][1]) {

	int i, j, k;
	float sum = 0;

	for (i = 0; i < 4; i++) {
		for (j = 0; j < 1; j++) {
			sum = 0;
			for (k = 0; k < 4; k++) {
				sum = sum + a[i][k] * b[k][j];
			}
			c[i][j] = sum;
		}
	}
}

void printMatrix(int row, int col, float m[row][col]) {
	int i, j;
	
	printf ("------------------------\n");
	
	for (i = 0; i < row; i++) {
		for (j = 0; j < col; j++) {
			printf(" %f ", m[i][j]);
		}
		printf("\n");
	}
	
	printf ("------------------------\n");
}

void getRotationMatrix(int angle_x, int angle_y, int angle_z, float m[4][4]) {
	
	float rad_x = angle_x * .01743;
	float rad_y = angle_y * .01743;
	float rad_z = angle_z * .01743;	

	float temp[4][4];

	float rotate_x[4][4] = {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 1}};
	float rotate_y[4][4] = {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 1}};
	float rotate_z[4][4] = {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 1}};

	rotate_x[1][1] = cos(rad_x); 
	rotate_x[1][2] = sin(rad_x);
	rotate_x[2][1] = -sin(rad_x);
	rotate_x[2][2] = cos(rad_x);

	rotate_y[0][0] = cos(rad_y); 
	rotate_y[0][2] = -sin(rad_y);
	rotate_y[2][0] = sin(rad_y);
	rotate_y[2][2] = cos(rad_y);

	rotate_z[0][0] = cos(rad_z); 
	rotate_z[0][1] = -sin(rad_z);
	rotate_z[1][0] = sin(rad_z);
	rotate_z[1][1] = cos(rad_z);	

	dotProduct44(rotate_y, rotate_x, temp);
	dotProduct44(rotate_z, temp, m);
}